/*
md2View v0.01 -  md2    Quake2.
        md2.cfg.
     pcx c 8   .

  md2
http://tfc.duke.free.fr/old/models/md2.htm

iadn
http://www.iadn.narod.ru
iadn@bk.ru
*/


#include<menuet/os.h>
#include <kosgl.h> //TinyGL
#include <string.h>

#include "loadmd2.h"
#include "SysCall.h"
#include "ProcessTab.h"

int Fps (long x, long y);
extern "C"{
void app_main(void);
}

struct {
	   int x,y;
	   int dx,dy;
	   } win;

#define KEY_ESC       1
#define KEY_F     	 33

#define KEY_L     	 38
#define KEY_P     	 25
#define KEY_S     	 31
#define KEY_T     	 20

#define KEY_LEFT     75
#define KEY_RIGHT    77
#define KEY_UP       72
#define KEY_DOWN     80

char *title1 = "md2View v0.01";
char *title2 = "<-/->,Up/Down camera, F full screen, T text, S/L/P render mode";
char *title3 = "ESC - exit";
char *fps    = "FPS:"; 

unsigned char FullScreen = 0;
unsigned char skin = 3;

process_table_entry_* pri;
KOSGLContext cgl;

GLfloat lightpos[4] = {0.0, 0.0, 0.2, 1.0};
GLfloat lightdirect[3] = {-0.5, -0.6, -0.7};

float angle_light = 0.0;
float angle = 0.0;
float dist = -60.0;

float interp=0.0;
float dinterp=0.001;

int anim=0;
int speed_anim;

unsigned char Texture = 1;

void DrawGL() 
{
  speed_anim = Fps (540,8);
  
  glLoadIdentity();
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glTranslatef(0.0, 0.0, dist);

  glPushMatrix(); 
  glRotatef(-6.0*angle_light, 0.0, 1.0, 0.0);
  if (angle_light <= 360.0) angle_light += speed_anim*0.06;
  else angle_light = 0.0;  
   
  glTranslatef(0.0, 45.0, -90.0);
  
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  glPopMatrix();

  glPushMatrix(); 
  glTranslatef(0.0, 0.0, -90.0);
  glRotatef(-90.0, 1.0, 0.0, 0.0); 
  glRotatef(-90.0, 0.0, 0.0, 1.0); 
  
  glRotatef(angle, 0.0, 0.0, 1.0);
 
  for(int i=0; i<NumModel; i++){
  	RenderFrameItpWithGLCmds (anim, interp, mdl_model[i]);
  }

  interp += (dinterp+speed_anim*0.07);
  if(interp>=1.0){
   interp = 0.0;
   anim++;
   if(anim>=mdl_model[0]->header.num_frames-1)anim = 0;     
   }
  glPopMatrix();

  kosglSwapBuffers(); 
} 

void reshape()
{   
	   __menuet__get_process_table((process_table_entry*)pri,-1);
   	   glViewport(0, 0, pri->winx_size, pri->winy_size-20);
	   glMatrixMode(GL_PROJECTION);
	   glLoadIdentity();
	   gluPerspective(40.0, (GLfloat)pri->winx_size/pri->winy_size, 1.0, 400.0);
	   glMatrixMode(GL_MODELVIEW);
	   glLoadIdentity();
	   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );   
} 

void disabletgl()
{
	kosglDestroyContext(cgl); 
	delete pri;
}

void Title()
{
     __menuet__write_text(510,8,0x10ffffff,fps,strlen(fps));
     __menuet__write_text(8,8,0x10ffffff,title1,strlen(title1));
	 __menuet__write_text(120,8,0x00ffffff,title2,strlen(title2));
     __menuet__write_text(600,8,0x00ffffff,title3,strlen(title3));
}

void draw_window(void)
{
	// start redraw
	__menuet__window_redraw(1);
	// define&draw window
	__menuet__define_window(win.x,win.y,win.dx,win.dy,TYPEWIN(0,0,0,1,skin,0,0,0),0,0);
    // end redraw
    __menuet__window_redraw(2);
    // display string
    Title();
}

void app_main(void)          
{
	 
  win.x = 100;
  win.y = 100;
  win.dx = 600;
  win.dy = 500;

  draw_window();

  cgl = kosglCreateContext( 0, 0);
  kosglMakeCurrent( 0, 20, win.dx, win.dy-20, cgl);
 
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glClearColor (0.1, 0.1, 0.3, 1.0); 
  
  glEnable(GL_LIGHTING);
  glLightf(GL_LIGHT0, GL_SPOT_EXPONENT, 0.0);
  glLightf(GL_LIGHT0, GL_SPOT_CUTOFF, 110.0);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, lightdirect); 
  
  glEnable(GL_COLOR_MATERIAL);
  glEnable(GL_NORMALIZE);
  
  glClearDepth(1.0);
  glFrontFace(GL_CW);
  glEnable( GL_CULL_FACE );
  glEnable(GL_DEPTH_TEST);
  
  // Setup texturing 
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
  glEnable(GL_TEXTURE_2D);
  
  LoadConfigFile("md2.cfg");
  
  pri=new process_table_entry_;
  SysCall(66,1,1);
  
  reshape();

do{
 
 DrawGL();
				
		  switch(__menuet__check_for_event())
		      {
		          case 1: draw_window();				  	   	  
				  	   	  reshape();
				  	   	  break;
				  	   	  
		          case 2: 		          
		          	   switch(__menuet__getkey()){
		                  						  			
                           case KEY_RIGHT:
                                    angle -= 0.9+speed_anim*0.6;
						  			break;
						  			
						   case KEY_LEFT:
                                    angle += 0.9+speed_anim*0.6;
						  			break;
						  									  			
						   case KEY_DOWN:
                                    dist -= 0.9+speed_anim*0.6;
						            if(dist<=-200.0) dist = -200.0;
						  			break;
						  			
						   case KEY_UP:
                                    dist += 0.9+speed_anim*0.6;
						            if(dist>=1.0) dist = 1.0;
						  			break;
						  			
						   case KEY_F:
                                    if(!FullScreen){									 
									 skin=0;
									 SysCall(67,0,0,SysCall(14)>>16,SysCall(14)&0xffff);
									 draw_window();
									 reshape();
									 FullScreen = 1;
									}
									else{
									 skin=3;
									 draw_window();								 
									 SysCall(67,win.x,win.y,win.dx,win.dy);
									 reshape();
									 FullScreen = 0;
									};
						  			break;
						  			
						   case KEY_T:
                                    if(Texture){
												glDisable(GL_TEXTURE_2D);
												Texture = 0;
												}
									else        {
										 		glEnable(GL_TEXTURE_2D);
												Texture = 1;
										        }
						  			break;
						  			
						   case KEY_S:
                                    glPolygonMode(GL_FRONT,GL_FILL);
						  			break;
						   
						   case KEY_L:
                                    glPolygonMode(GL_FRONT,GL_LINE);
						  			break;
						   
						   case KEY_P:
                                    glPolygonMode(GL_FRONT,GL_POINT);
						  			break;						   
						   
                           case KEY_ESC: disabletgl();
						  				 return;}
						  				 break;
						  			
			  	  case 3: disabletgl();
						  return;
		      }
}while(1);
}
