/*
iadn
http://www.iadn.narod.ru
iadn@bk.ru
*/
#include "pcx.h"

#include <stdio.h>
#include <libc/stubs.h>

extern "C"{
long filelength(int fhandle);
}

struct  PCXHEAD{
  unsigned char manufacturer;
  unsigned char version;
  unsigned char encoding;
  unsigned char bitsPerPixel;
  short int xmin, ymin;
  short int xmax, ymax;
  short int hres, vres;
  char palette[48];
  char reserved;
  char colourPlanes;
  short int bytesPerLine;
  short int paletteType;
  char filler[58];
};

int LoadPCX(const char *filename, IMAGERGB *irgb)
{
     FILE *fp;
     PCXHEAD pcx_h;
     short int xsize, ysize;
     unsigned char pcxPal[256][3];//
     unsigned char* ImRGB;//   RGB 
     int n,k;
     unsigned char* prgb;//   
     unsigned char* prgb_tmp;
     int sizepak;
     
     fp = fopen(filename,"rb");
     if(!fp) return 0;
    
     fread (&pcx_h, sizeof (PCXHEAD), 1, fp);// 
    
     sizepak = filelength(fileno(fp)) - sizeof (PCXHEAD)-768;//  
     
	 prgb = new unsigned char[sizepak];//   
     prgb_tmp = prgb;
     fread (prgb, sizepak, 1, fp);//  

	 if(pcx_h.manufacturer!=0x0a) return NULL; //
	 if(pcx_h.version!=0x05) return NULL; //
	 if(pcx_h.encoding!=0x01) return NULL; //  - 01 -  
	 if(pcx_h.bitsPerPixel!=0x08) return NULL; //   -          8  
     
     xsize = pcx_h.xmax - pcx_h.xmin+1;// 
     ysize = pcx_h.ymax - pcx_h.ymin+1;
	
	 ImRGB = new unsigned char[xsize*ysize*3];//     RGB
	 irgb->image = ImRGB;

	 fread (pcxPal, 768, 1, fp);// 	 

	 k = xsize*ysize;//   
	 while (k>0)
     {
	  	
      	if ((*prgb & 0xC0) == 0xC0)//   
    	{//  
      	   n = *prgb & 0x3F;//         	
      	   prgb++;//   ,         
		}   
   	    else 
		{//   
		   n = 1;
		}

		while (n--)//   
		{
		   *ImRGB = pcxPal[*prgb][2];//b 
		   ImRGB++;
		   *ImRGB = pcxPal[*prgb][1];//g 
		   ImRGB++;
		   *ImRGB = pcxPal[*prgb][0];//r 
		   ImRGB++;
		   k--;			   
		   };
		 prgb++;//     
     };
 	
	 irgb->xsize = xsize; 
	 irgb->ysize = ysize;
	 
	 delete prgb_tmp;
	 fclose(fp);
	 
return 1;      
}



